# -*- test-case-name: quotient.test.test_peerup -*-
# This module is part of the Quotient project and is Copyright 2003 Divmod:
# http://www.divmod.org/.  This is free software.  You can redistribute it
# and/or modify it under the terms of version 2.1 of the GNU Lesser General
# Public License as published by the Free Software Foundation.

from atop import store
from atop import powerup

from atop.ifcompat import implements, backwardsCompatImplements

from twisted.python import components

class IPeerUp(components.Interface):
    def allocateStoreID(self):
        pass

class PeerStoreup(powerup.Storeup):

    implements(IPeerUp)

    powerupName = "Peer"

    def setUpPools(self, substore):
        p = store.Pool(substore, name="peers")
        self.peerRef = p.referenceTo()
        substore.setComponent(IPeerUp, self)

    def deleteFromStore(self):
        self.store.unsetComponent(IPeerUp)
        return powerup.Storeup.deleteFromStore(self)

    def allocateStoreID(self):
        L = self.getItemPath()
        L = L + ("remote.id",)
        # XXX
        return store.updateIDKey(self.store.db, store.SEP.join(map(str, L)))

    def remoteItemByPath(self, *path):
        # Special case for local stuff
        pass

backwardsCompatImplements(PeerStoreup)
